#-*- coding:utf-8 -*-
#python 2.7
import sys, os, base64, datetime, hashlib, hmac 
import requests # pip install requests
import urllib
import json


SMS_API = 'https://voice.api.ksyun.com/'
#ak sk
ACCESS_KEY = ''
SECRET_KEY = ''
if ACCESS_KEY is None or SECRET_KEY is None:
    print('No access key is available.')
    sys.exit()

#generate sign
def sign(params, secret_key):
    str_encode = ''
    param_keys = sorted(params.keys())
    for key in param_keys:
        str_encode += urllib.quote(key,'~') + '=' + urllib.quote(str(params[key]),'~') + '&'
    print(str_encode[:-1])
    return hmac.new(secret_key, str_encode[:-1], hashlib.sha256).hexdigest()

def makeSysParams(ak):
    t = datetime.datetime.utcnow()
    sys_params = {
        'Accesskey' : ak,
        'Timestamp' : t.strftime('%Y-%m-%dT%H:%M:%SZ'),
        'Service'   : 'voice',
        'Version'   : '2020-05-01',
        'SignatureVersion' : '1.0',
        'SignatureMethod'  : 'HMAC-SHA256',
        'Region'    : 'cn-beijing-6',
    }
    return sys_params

def callVerify(mobile, tpl_id, code = '', content = '', play_times = 2):
    request_parameters = makeSysParams(ACCESS_KEY)
    request_parameters['Action'] = 'CallVerify'
    request_parameters['Mobile'] = mobile
    if tpl_id :
        request_parameters['TplId'] = tpl_id
        request_parameters['Code']  = code
    else :
        request_parameters['Content']   = content
    request_parameters['PlayTimes'] = play_times
    request_parameters['Signature'] = sign(request_parameters, SECRET_KEY)
    print('\nBEGIN REQUEST++++++++++++++++++++++++++++++++++++')
    print('Request URL = ' + SMS_API)

    headers = {'accept':'application/json',
            'content-type':'application/x-www-form-urlencoded'}
    r = requests.post(SMS_API, data=request_parameters, headers=headers)

    print('\nRESPONSE++++++++++++++++++++++++++++++++++++')
    print('Response code: %d\n' % r.status_code)
    print(r.text)

def callNotify(mobile, tpl_id, tpl_params, content = '', play_times = 1):
    request_parameters = makeSysParams(ACCESS_KEY)
    request_parameters['Action'] = 'CallNotify'
    request_parameters['Mobile'] = mobile
    if tpl_id :
        request_parameters['TplId']     = tpl_id
        request_parameters['TplParams'] = json.JSONEncoder().encode(tpl_params)
    else :
        request_parameters['Content']   = content
    request_parameters['PlayTimes'] = play_times
    request_parameters['Signature'] = sign(request_parameters, SECRET_KEY)
    print('\nBEGIN REQUEST++++++++++++++++++++++++++++++++++++')
    print('Request URL = ' + SMS_API)

    headers = {'accept':'application/json',
            'content-type':'application/x-www-form-urlencoded'}
    r = requests.post(SMS_API, data=request_parameters, headers=headers)

    print('\nRESPONSE++++++++++++++++++++++++++++++++++++')
    print('Response code: %d\n' % r.status_code)
    print(r.text)


# ************* SEND API *************

#callVerify('187xxxx', '100010', '31231')
callNotify('187xxxx', '', '')